# Soft Convex Quantized Variational Autoencoder

This is a PyTorch implementation of the soft convex quantized variational autoencoder. 

## Requirements
A suitable conda environment can be created and activated with the following commands.

```conda env create -f environment_vae_final.yaml
conda activate vae
```

## Replicate Experiments of CIFAR-10 and GTSRB
To replicate the results of Table 1 in the paper, first run the train_vae_model.py script. Within the script specify the quantization bottleneck with one of 
```
quant_type = {'scq', 'vq', 'vqreplace', 'vqaffineopt', 'vqreplaceaffineopt', 'rv', 'gumbel'}
```
## Acknowledgements
This codebase builds heavily on two previous repositories:
1. Implementation of VQ: [https://github.com/MishaLaskin/vqvae] and [https://github.com/rosinality/vq-vae-2-pytorch/tree/master] 
2. Implementation of VQ variants: [https://github.com/minyoungg/vqtorch]
